#include <iostream>
#include <string>
#include <typeinfo>
#include <stdio.h>
#include "TypeList.h"

using namespace std;

struct A
{
    static const char * name()
    {
        return "A";
    }
};

struct B
{
    static const char * name()
    {
        return "B";
    }
};

struct C
{
    static const char * name()
    {
        return "C";
    }
};

template <typename From,typename To>
struct print_move
{
    static void exec()
    {
        cout<<"Move Disk From "<<From::name()<<" to "<<To::name()<<endl;
    }
};

template <typename From,typename To,typename Via, int n>
struct transfer
{
    typedef typename Loki::TL::Append<typename transfer<From,Via,To,n-1>::type,Loki::Typelist<print_move<From,To>,Loki::NullType> >::Result type0;
    typedef typename Loki::TL::Append<type0,typename transfer<Via,To,From,n-1>::type>::Result type;
};

template <typename From,typename To,typename Via>
struct transfer<typename From,typename To,typename Via, 1>
{
    typedef Loki::Typelist<print_move<From,To>,Loki::NullType> type;
};

template <typename FnList>
struct eval
{
};

template <typename Fn,typename Fns>
struct eval <Loki::Typelist<Fn,Fns> >
{
    static void exec()
    {
        Fn::exec();
        eval<Fns>::exec();
    }
};

template <>
struct eval <Loki::NullType>
{
    static void exec()
    {
    }
};

int main()
{
    eval<typename transfer<A,B,C,3>::type>::exec();
}