conc_atom([H|T],A):-
    conc_atom(T,_A),atom_concat(H,_A,A).

conc_atom([A],A):- !.

write_message(Message):-
    is_list(Message), conc_atom(Message,MsgAtom),writeln(MsgAtom);
    writeln(Message).

:- op(40,xfx,to).

to(A,B):-
    write_message(['Move disk from ',A,' to ',B]).

hanoi(A,B,_,1,[A to B]).

hanoi(A,B,C,N,Moves) :-
    NN is N-1,
    hanoi(A,C,B,NN,Ms1),
    hanoi(C,B,A,NN,Ms2),
    append(Ms1,[A to B|Ms2],Moves).

eval([Goal | Gs]):-
Goal,!,eval(Gs).

eval([]).