import Thor.typelist;
import Thor.meta;
import std.stdio;

class A{}
class B{}
class C{}

template PrintMove(From,To)
{
    struct PrintMove
    {
        static void eval()
        {
            writef("Move Disk From %s to %s\n",typeid(From).toString(),typeid(To).toString());
        }
    }
}

template Transfer(From,To,Via,int n : 1)
{
    alias TL!(PrintMove!(From,To)) Transfer;
}

template Transfer(From,To,Via,int n)
{
    alias Append!(Append!(.Transfer!(From,Via,To,n-1),TL!(PrintMove!(From,To))),
                  .Transfer!(Via,To,From,n-1)) Transfer;
}

template Eval(TL_ : TypeList)
{
    void Eval()
    {
        TL_.H.eval();
        .Eval!(TL_.T)();
    }
}

template Eval(T : NullT)
{
    void Eval()
    {
    }
}

void main()
{
    Eval!(Transfer!(A,B,C,3))();
}